// ASCII & HANGUL font drawing Library. by NKJ.  2010.02

void LcdAsciiChar(unsigned int x, unsigned int y, unsigned char ch, unsigned int rgb, unsigned int back_rgb)
{
    unsigned int addr;
    unsigned int n,m;
    
    addr=(unsigned int)ch*16;

    LcdSetWindow(x,y,8,16);    
    LcdDataStart();    
    for(n=0;n<16;n++)
     {   
        for(m=0;m<8;m++)
          {  if(asc_fnt[addr+n]&(0x80>>m))
               { LcdDataWrite(rgb);
               }
             else 
               { LcdDataWrite(back_rgb); 
               }
          }
     }
   LcdDataEnd();
}  


void LcdAsciiCharCT(unsigned int x, unsigned int y, unsigned char ch, unsigned int rgb) // ClearType character
{
    unsigned int addr;
    unsigned int n,m;
    
    addr=(unsigned int)ch*16;

    for(n=0;n<16;n++)
     {   
        for(m=0;m<8;m++)
          {  if(asc_fnt[addr+n]&(0x80>>m))
               { setpixel(x+m,y+n,rgb);
               }
          }
     }
}


void LcdAsciiString(unsigned int x, unsigned int y, unsigned char const *str, unsigned int rgb, unsigned int back_rgb)
{
    unsigned int n;
    
    for(n=0;str[n]!='\0';n++)
      {  LcdAsciiChar(x+(8*n),y,str[n],rgb,back_rgb);
      }
}

             

void LcdAsciiStringCT(unsigned int x, unsigned int y, unsigned char const *str, unsigned int rgb)  // ClearType character
{
    unsigned int n;
    
    for(n=0;str[n]!='\0';n++)
      {  LcdAsciiCharCT(x+(8*n),y,str[n],rgb);
      }
}



          
void LcdHangulChar(unsigned int x, unsigned int y, unsigned char const *ch, unsigned int rgb, unsigned int back_rgb)
{
  unsigned char  chosung=0,joongsung=0,jongsung=0;
  unsigned char  cho=0,joong=0,jong=0;
  unsigned int   cho_add=0,joong_add=0,jong_add=0;
  unsigned char  count=0;
  unsigned char  n;
  unsigned char  fnt_data;

  chosung = ch[0] & 0x7c;
  chosung = chosung>>2;
  joongsung= (ch[0] & 0x03)<<3;
  jongsung=(ch[1] &0xe0)>>5;
  joongsung=joongsung | jongsung;
  jongsung= ch[1] & 0x1f;

  if(jongsung==0x01||jongsung==0x00||jongsung==0x12)
    {
     jong=0;
     if((chosung==0x02)||(chosung==0x11))  joong=1;
     else joong=2;

    if((joongsung==0x03)||(joongsung==0x04)||(joongsung==0x05)||(joongsung==0x06)||(joongsung==0x07)||
       (joongsung==0x0a)||(joongsung==0x0b)||(joongsung==0x0c)||(joongsung==0x1d)) cho=1;
    else if ((joongsung==0x0d)||(joongsung==0x13)||(joongsung==0x1b)) cho=2;
    else if ((joongsung==0x14)||(joongsung==0x1a)) cho=3;
    else if ((joongsung==0x0e)||(joongsung==0x0f)||(joongsung==0x12)||(joongsung==0x1c)) cho=4;
    else cho = 5;
    }
  else
    {
      if((joongsung==0x03)||(joongsung==0x05)||(joongsung==0x0e)) jong =1;
      else if ((joongsung==0x07)||(joongsung==0x0b)||(joongsung==0x12)||(joongsung==0x15)
	       ||(joongsung==0x17)||(joongsung==0x1c)||(joongsung==0x1d)) jong=2;
      else if((joongsung==0x04)||(joongsung==0x06)||(joongsung==0x0a)||(joongsung==0x0c)
	       ||(joongsung==0x0f)||(joongsung==0x16)) jong =3;
      else  jong=4;

      if((chosung==0x02)||(chosung==0x11))  joong=3;
      else joong=4;


      if((joongsung==0x03)||(joongsung==0x04)||(joongsung==0x05)||(joongsung==0x06)||(joongsung==0x07)
	||(joongsung==0x0a)||(joongsung==0x0b)||(joongsung==0x0c)||(joongsung==0x1d)) cho=6;
      else if((joongsung==0x0d)||(joongsung==0x13)||(joongsung==0x1b)||(joongsung==0x14)
	||(joongsung==0x1a)) cho=7;
      else cho = 8;
    }

  chosung=chosung-2;

  if(joongsung<=0x07)joongsung=joongsung-3;
  else if(joongsung<=0x0f)joongsung=joongsung-5;
  else if(joongsung<=0x17)joongsung=joongsung-7;
  else joongsung=joongsung-9;

  if(jongsung<=0x11)jongsung=jongsung-2;
  else jongsung=jongsung-3;

  if(cho==1) cho_add=((unsigned int)(chosung)*32);
  else if(cho==2) cho_add=0x0260+((unsigned int)(chosung)*32);
  else if(cho==3) cho_add=0x04c0+((unsigned int)(chosung)*32);
  else if(cho==4) cho_add=0x0720+((unsigned int)(chosung)*32);
  else if(cho==5) cho_add=0x0980+((unsigned int)(chosung)*32);
  else if(cho==6) cho_add=0x0be0+((unsigned int)(chosung)*32);
  else if(cho==7) cho_add=0x0e40+((unsigned int)(chosung)*32);
  else if(cho==8) cho_add=0x10a0+((unsigned int)(chosung)*32);
  else cho_add=0x2B10;     //BLANK..

  if(joong==1) joong_add=0x1300+((unsigned int)(joongsung)*32);
  else if(joong==2) joong_add=0x15a0+((unsigned int)(joongsung)*32);
  else if(joong==3) joong_add=0x1840+((unsigned int)(joongsung)*32);
  else if(joong==4) joong_add=0x1ae0+((unsigned int)(joongsung)*32);
  else joong_add=0x2B10;

  if(jong==1) jong_add=0x1d80+((unsigned int)(jongsung)*32);
  else if(jong==2) jong_add=0x20e0+((unsigned int)(jongsung)*32);
  else if(jong==3) jong_add=0x2440+((unsigned int)(jongsung)*32);
  else if(jong==4) jong_add=0x27a0+((unsigned int)(jongsung)*32);
  else jong_add=0x2B10;

  LcdSetWindow(x,y,16,16);
  LcdDataStart();
  for(count=0;count<32;count++)
    { 
        fnt_data=hg_fnt[cho_add+count]|hg_fnt[joong_add+count]|hg_fnt[jong_add+count];
        for(n=0;n<8;n++)
          {  if(fnt_data&(0x80>>n))
               { LcdDataWrite(rgb);
               }
             else 
               { LcdDataWrite(back_rgb); 
               }
          }
     }
  LcdDataEnd();
}

         
void LcdHangulCharCT(unsigned int x, unsigned int y, unsigned char const *ch, unsigned int rgb)  // ClearType
{
  unsigned char  chosung=0,joongsung=0,jongsung=0;
  unsigned char  cho=0,joong=0,jong=0;
  unsigned int   cho_add=0,joong_add=0,jong_add=0;
  unsigned char  count=0;
  unsigned char  n;
  unsigned char  fnt_data;

  chosung = ch[0] & 0x7c;
  chosung = chosung>>2;
  joongsung= (ch[0] & 0x03)<<3;
  jongsung=(ch[1] &0xe0)>>5;
  joongsung=joongsung | jongsung;
  jongsung= ch[1] & 0x1f;

  if(jongsung==0x01||jongsung==0x00||jongsung==0x12)
    {
     jong=0;
     if((chosung==0x02)||(chosung==0x11))  joong=1;
     else joong=2;

    if((joongsung==0x03)||(joongsung==0x04)||(joongsung==0x05)||(joongsung==0x06)||(joongsung==0x07)||
       (joongsung==0x0a)||(joongsung==0x0b)||(joongsung==0x0c)||(joongsung==0x1d)) cho=1;
    else if ((joongsung==0x0d)||(joongsung==0x13)||(joongsung==0x1b)) cho=2;
    else if ((joongsung==0x14)||(joongsung==0x1a)) cho=3;
    else if ((joongsung==0x0e)||(joongsung==0x0f)||(joongsung==0x12)||(joongsung==0x1c)) cho=4;
    else cho = 5;
    }
  else
    {
      if((joongsung==0x03)||(joongsung==0x05)||(joongsung==0x0e)) jong =1;
      else if ((joongsung==0x07)||(joongsung==0x0b)||(joongsung==0x12)||(joongsung==0x15)
	       ||(joongsung==0x17)||(joongsung==0x1c)||(joongsung==0x1d)) jong=2;
      else if((joongsung==0x04)||(joongsung==0x06)||(joongsung==0x0a)||(joongsung==0x0c)
	       ||(joongsung==0x0f)||(joongsung==0x16)) jong =3;
      else  jong=4;

      if((chosung==0x02)||(chosung==0x11))  joong=3;
      else joong=4;


      if((joongsung==0x03)||(joongsung==0x04)||(joongsung==0x05)||(joongsung==0x06)||(joongsung==0x07)
	||(joongsung==0x0a)||(joongsung==0x0b)||(joongsung==0x0c)||(joongsung==0x1d)) cho=6;
      else if((joongsung==0x0d)||(joongsung==0x13)||(joongsung==0x1b)||(joongsung==0x14)
	||(joongsung==0x1a)) cho=7;
      else cho = 8;
    }

  chosung=chosung-2;

  if(joongsung<=0x07)joongsung=joongsung-3;
  else if(joongsung<=0x0f)joongsung=joongsung-5;
  else if(joongsung<=0x17)joongsung=joongsung-7;
  else joongsung=joongsung-9;

  if(jongsung<=0x11)jongsung=jongsung-2;
  else jongsung=jongsung-3;

  if(cho==1) cho_add=((unsigned int)(chosung)*32);
  else if(cho==2) cho_add=0x0260+((unsigned int)(chosung)*32);
  else if(cho==3) cho_add=0x04c0+((unsigned int)(chosung)*32);
  else if(cho==4) cho_add=0x0720+((unsigned int)(chosung)*32);
  else if(cho==5) cho_add=0x0980+((unsigned int)(chosung)*32);
  else if(cho==6) cho_add=0x0be0+((unsigned int)(chosung)*32);
  else if(cho==7) cho_add=0x0e40+((unsigned int)(chosung)*32);
  else if(cho==8) cho_add=0x10a0+((unsigned int)(chosung)*32);
  else cho_add=0x2B10;     //BLANK..

  if(joong==1) joong_add=0x1300+((unsigned int)(joongsung)*32);
  else if(joong==2) joong_add=0x15a0+((unsigned int)(joongsung)*32);
  else if(joong==3) joong_add=0x1840+((unsigned int)(joongsung)*32);
  else if(joong==4) joong_add=0x1ae0+((unsigned int)(joongsung)*32);
  else joong_add=0x2B10;

  if(jong==1) jong_add=0x1d80+((unsigned int)(jongsung)*32);
  else if(jong==2) jong_add=0x20e0+((unsigned int)(jongsung)*32);
  else if(jong==3) jong_add=0x2440+((unsigned int)(jongsung)*32);
  else if(jong==4) jong_add=0x27a0+((unsigned int)(jongsung)*32);
  else jong_add=0x2B10;

  for(count=0;count<32;count=count+2)
    { 
        fnt_data=hg_fnt[cho_add+count]|hg_fnt[joong_add+count]|hg_fnt[jong_add+count];
        for(n=0;n<8;n++)
          {  if(fnt_data&(0x80>>n))
               { setpixel(x+n,y+(count/2),rgb);
               }
          }
        fnt_data=hg_fnt[cho_add+count+1]|hg_fnt[joong_add+count+1]|hg_fnt[jong_add+count+1];
        for(n=0;n<8;n++)
          {  if(fnt_data&(0x80>>n))
               { setpixel(x+n+8,y+(count/2),rgb);
               }
          }          
     }
}





void LcdHangulString(unsigned int x, unsigned int y, unsigned char const *str, unsigned int rgb, unsigned int back_rgb)
{
    unsigned int n;
    
    for(n=0;str[n]!='\0';n+=2)
      {  LcdHangulChar(x+(8*n),y,&str[n],rgb,back_rgb);
      }
}



void LcdHangulStringCT(unsigned int x, unsigned int y, unsigned char const *str, unsigned int rgb)  // ClearType
{
    unsigned int n;
    
    for(n=0;str[n]!='\0';n+=2)
      {  LcdHangulCharCT(x+(8*n),y,&str[n],rgb);
      }
}



void LcdString(unsigned int x, unsigned int y, unsigned char const *str, unsigned int rgb, unsigned int back_rgb)
{
    unsigned int n;
    
    for(n=0;str[n]!='\0';n++)
      {
         if(str[n]&0x80)
           {  LcdHangulChar(x+(8*n),y,&str[n],rgb,back_rgb);
              n++;
           }
         else
           {  LcdAsciiChar(x+(8*n),y,str[n],rgb,back_rgb);
           }
      }
}                           


void LcdStringCT(unsigned int x, unsigned int y, unsigned char const *str, unsigned int rgb)  // ClearType
{
    unsigned int n;
    
    for(n=0;str[n]!='\0';n++)
      {
         if(str[n]&0x80)
           {  LcdHangulCharCT(x+(8*n),y,&str[n],rgb);
              n++;
           }
         else
           {  LcdAsciiCharCT(x+(8*n),y,str[n],rgb);
           }
      }
}                           

